package common;

import java.util.Vector;

public class ThreadPool {
	public static int WAITING_THREADS=3;
	Vector waitingThreads=new Vector(WAITING_THREADS*2);
	
	class WorkerThread extends Thread {
		private Runnable runnable=new Runnable() {public void run() {}};
		private int runs=100;
		
		public void run() {
			while (runs-- > 0) {
					while (runnable==null) {
						synchronized (this) {
							try {
								wait();
							} catch (InterruptedException e) {
						}
					}
				}
				try {
					runnable.run();
				} catch (Exception e) {
					e.printStackTrace();
				}
				runnable=null;
				waitingThreads.add(this);
			}
		}
		public synchronized void setRunnable(Runnable runnable) {
			this.runnable=runnable;
			this.notify();
		}
	}

	public ThreadPool() {
		ensurePool();
	}
	private void ensurePool() {
		for (int i=waitingThreads.size(); i< WAITING_THREADS; i++) {
			new WorkerThread().start();//Will automatic add itself to waiting threads
		}
	}
	
	public void runTask(Runnable runnable) {
		WorkerThread thread=(WorkerThread)waitingThreads.remove(0);
		thread.setRunnable(runnable);
		ensurePool();
	}
	
}
