package demux.ty;

import java.nio.ByteBuffer;

public class ChunkHeader {
	public int records;
	public int sequenceRecord;
	public int marker2;
	public boolean version2plus;
	
	public int parse(ByteBuffer chunk) {
		//Test marker bit
		version2plus=(chunk.get(3)&0x80) > 0;
		if (version2plus) {
			//LSB
			records=(chunk.get(0)&0xff) + ((chunk.get(1)&0xff) <<8);
			sequenceRecord=(chunk.get(2)&0xff) + ((chunk.get(3)&0xFE) <<7);
			marker2=0;
		} else {
			records=chunk.get(0)&0xff;
			sequenceRecord=chunk.get(1)&0xff;
			marker2=chunk.get(1)&0x01;
		}
		return 4;
	}
	public int parse(final byte chunk[]) {
		//Test marker bit
		version2plus=(chunk[3]&0x80) > 0;
		if (version2plus) {
			//LSB
			records=(chunk[0]&0xff) + ((chunk[1]&0xff) <<8);
			sequenceRecord=(chunk[2]&0xff) + ((chunk[3]&0xFE) <<7);
			marker2=0;
		} else {
			records=chunk[0]&0xff;
			sequenceRecord=chunk[1]&0xff;
			marker2=chunk[1]&0x01;
		}
		return 4;
	}
	
	public int getDataOffset() {
		return 4 + this.records * 16;
	}
}
