package ui.tobluray;

import io.NameTypeFileFilter;

import javax.swing.JFileChooser;

import common.DiskFinder;

import ui.ToUI;
import ui.tonmt.ToNmtPreferenceDialog;
import ui.tonmt.ToNMTPrefs;
import demux.pes.XplHelper;

public class ToBluRayUI extends ToUI {
	private static final String NAME="To Blu-Ray 1.0";
	
	protected ToNMTPrefs getPrefs() {
		return ToNMTPrefs.getPrefs();
	}
	
	protected ToNmtPreferenceDialog getPreferenceDialog() {
		return new ToNmtPreferenceDialog();
	}
	
	public static void main(String args[]) {
		ToBluRayUI frame = new ToBluRayUI();
		frame.setVisible(true);
	}
	
	protected ToBluRayUI() {
		super(NAME);
		inputFileChooser=new JFileChooser();
		inputFileChooser.addChoosableFileFilter(new NameTypeFileFilter(new String[]{".evo"}, "HD DVD Stream"));
		inputFileChooser.addChoosableFileFilter(new NameTypeFileFilter(new String[]{XplHelper.HD_HDVD_PLAYLIST_EXT}, "HD DVD Playlists"));
		inputFileChooser.setAcceptAllFileFilterUsed(false);
		inputFileChooser.setMultiSelectionEnabled(true);

		saveAsFileChooser=new JFileChooser();
		saveAsFileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		saveAsFileChooser.setMultiSelectionEnabled(false);
		saveAsFileChooser.setDialogType(JFileChooser.SAVE_DIALOG);

		diskFinder=new DiskFinder(false, true);
	}
}
